/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.antrax.storage.enums.SIMEvent;
import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.convert.IccidConverter;
import com.flamesgroup.storage.convert.SimEventConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.SimEventLogRecord;
import com.flamesgroup.unit.ICCID;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class SimEventLog extends TableImpl<SimEventLogRecord> {

	private static final long serialVersionUID = -735202017;

	/**
	 * The reference instance of <code>public.sim_event_log</code>
	 */
	public static final SimEventLog SIM_EVENT_LOG = new SimEventLog();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<SimEventLogRecord> getRecordType() {
		return SimEventLogRecord.class;
	}

	/**
	 * The column <code>public.sim_event_log.id</code>.
	 */
	public final TableField<SimEventLogRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim_event_log.iccid</code>.
	 */
	public final TableField<SimEventLogRecord, ICCID> ICCID = createField("iccid", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new IccidConverter());

	/**
	 * The column <code>public.sim_event_log.event</code>.
	 */
	public final TableField<SimEventLogRecord, SIMEvent> EVENT = createField("event", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new SimEventConverter());

	/**
	 * The column <code>public.sim_event_log.start_time</code>.
	 */
	public final TableField<SimEventLogRecord, Date> START_TIME = createField("start_time", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaulted(true), this, "", new DateConverter());

	/**
	 * The column <code>public.sim_event_log.args</code>.
	 */
	public final TableField<SimEventLogRecord, String[]> ARGS = createField("args", org.jooq.impl.SQLDataType.CLOB.getArrayDataType(), this, "");

	/**
	 * Create a <code>public.sim_event_log</code> table reference
	 */
	public SimEventLog() {
		this("sim_event_log", null);
	}

	/**
	 * Create an aliased <code>public.sim_event_log</code> table reference
	 */
	public SimEventLog(String alias) {
		this(alias, SIM_EVENT_LOG);
	}

	private SimEventLog(String alias, Table<SimEventLogRecord> aliased) {
		this(alias, aliased, null);
	}

	private SimEventLog(String alias, Table<SimEventLogRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<SimEventLogRecord, Long> getIdentity() {
		return Keys.IDENTITY_SIM_EVENT_LOG;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<SimEventLogRecord> getPrimaryKey() {
		return Keys.SIM_EVENT_LOG_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<SimEventLogRecord>> getKeys() {
		return Arrays.<UniqueKey<SimEventLogRecord>>asList(Keys.SIM_EVENT_LOG_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SimEventLog as(String alias) {
		return new SimEventLog(alias, this);
	}

	/**
	 * Rename this table
	 */
	public SimEventLog rename(String name) {
		return new SimEventLog(name, null);
	}
}
